Apprendre l'anxiété : Psychopédagogie

Une première étape importante pour surmonter un problème psychologique est d'en apprendre davantage à son sujet, ce que l'on appelle la "psychoéducation".

Apprendre à connaître votre problème peut vous apporter le réconfort de savoir que vous n'êtes pas seul et que d'autres ont trouvé des stratégies utiles pour le surmonter.
 Vous pouvez même trouver utile que les membres de votre famille et vos amis en apprennent également davantage sur votre problème. Certaines personnes trouvent que le simple
 fait de mieux comprendre leurs problèmes constitue un grand pas vers la guérison.

Par exemple, une personne souffrant de fréquentes attaques de panique commencerait par apprendre ce qu'est une attaque de panique (voir Trouble panique). En se renseignant
 sur la panique, elle découvrirait que, bien qu'une attaque de panique soit une expérience inconfortable, elle est temporaire et sans danger.

Un thérapeute TCC est en mesure de fournir des informations utiles sur votre problème particulier, mais vous pouvez également trouver des informations par vous-même auprès
 de sources réputées dans les librairies et sur Internet.

La psychoéducation est une première étape essentielle, mais il est important de se rappeler qu'elle n'est qu'une partie d'un plan de traitement complet.
Stratégies de relaxation

Apprendre à détendre son corps peut être un élément utile de la thérapie. La tension musculaire et la respiration superficielle sont toutes deux liées au stress et à l'anxiété 
(et parfois à la dépression). Il est donc important de prendre conscience de ces sensations corporelles et de pratiquer régulièrement des exercices pour apprendre à se détendre.

Deux stratégies souvent utilisées dans le cadre de la TCC sont la respiration calme, qui consiste à ralentir consciemment la respiration, et la relaxation musculaire progressive,
 qui consiste à contracter et détendre systématiquement différents groupes de muscles. Comme pour toute autre compétence, plus vous pratiquerez ces stratégies de relaxation, 
plus elles seront efficaces et rapides. D'autres stratégies de relaxation utiles comprennent l'écoute de musique calme, la méditation, le yoga et les massages.

Il est toutefois important de comprendre que l'objectif de la relaxation n' est pas d'éviter ou d'éliminer l'anxiété (car l'anxiété n'est pas dangereuse), mais de rendre un peu
 plus facile la gestion de ces sentiments.
Réflexion réaliste

Pour gérer efficacement les émotions négatives, il faut identifier les pensées négatives et les remplacer par des pensées réalistes et équilibrées. Étant donné que nos pensées
 ont un impact important sur la façon dont nous nous sentons, changer nos pensées inutiles en pensées réalistes ou utiles est un élément clé pour se sentir mieux. "Penser de 
façon réaliste" signifie porter un regard équilibré et juste sur soi-même, sur les autres et sur le monde, sans être excessivement négatif ou positif. Par exemple :
Pensée inutile et irréaliste 	Une pensée plus réaliste et plus équilibrée
Je fais toujours tout foirer, je suis un tel raté. Qu'est-ce qui ne va pas chez moi ? 	Tout le monde fait des erreurs, y compris moi - je ne suis qu'un être humain. Tout ce que
 je peux faire maintenant, c'est faire de mon mieux pour réparer la situation et tirer les leçons de cette expérience.
Je ne peux pas le faire. Je suis trop anxieuse. Pourquoi je n'arrive pas à contrôler mon anxiété ? 	C'est normal et normal d'être anxieux. Ce n'est pas dangereux, et cela ne doit
 pas m'arrêter. Je peux me sentir anxieuse et aller quand même à la fête.
Les étapes d'une réflexion réaliste

Sachez ce que vous pensez ou vous dites. La plupart d'entre nous n'ont pas l'habitude de prêter attention à la façon dont nous pensons, même si nous sommes constamment affectés 
par nos pensées. Le fait de prêter attention à vos pensées (ou monologue intérieur) peut vous aider à déterminer le type de pensées que vous avez habituellement.

Une fois que vous êtes plus conscient de vos pensées, essayez d'identifier les pensées qui vous font vous sentir mal, et déterminez s'il s'agit de pensées problématiques qui doivent
 être remises en question. Par exemple, si vous vous sentez triste en pensant à votre grand-mère qui se bat contre un cancer, cette pensée n'a pas besoin d'être remise en question 
car il est tout à fait normal de se sentir triste en pensant à un être cher qui souffre. Mais si vous vous sentez triste après qu'un ami a annulé votre déjeuner et que vous commencez
 à penser qu'il y a manifestement quelque chose qui ne va pas chez vous et que personne ne vous aime, cela pose problème car cette pensée est extrême et ne repose pas sur la réalité.

Prêtez attention à l'évolution de votre émotion, aussi minime soit-elle. Lorsque vous remarquez que vous êtes de plus en plus bouleversé ou angoissé, demandez-vous : "Qu'est-ce que
 je me dis en ce moment ?" ou "Qu'est-ce qui me fait me sentir bouleversé ?".

Lorsque vous avez l'habitude d'identifier les pensées qui conduisent à des émotions négatives, commencez à examiner ces pensées pour voir si elles sont irréalistes et inutiles. 
L'une des premières choses à faire est de voir si vous êtes tombé dans les pièges de la pensée (par exemple, catastrophisme ou surestimation du danger), qui sont des façons trop
 négatives de voir les choses. Vous pouvez également vous poser une série de questions pour remettre en question vos pensées négatives (voir Remettre en question les pensées 
négatives), comme "Quelles sont les preuves que cette pensée est vraie ?" et "Est-ce que je confonds une possibilité avec une probabilité ? C'est peut-être possible, mais est-ce
 probable ?"

Enfin, après avoir remis en question une pensée négative et l'avoir évaluée de manière plus objective, essayez de trouver une autre pensée plus équilibrée et plus réaliste. Cela peut
 contribuer à réduire votre détresse. En plus de trouver des énoncés réalistes, essayez de trouver des énoncés d'adaptation rapides et faciles à retenir (p. ex., "Cela m'est déjà 
arrivé et je sais comment le gérer") et des énoncés positifs (p. ex., "Il faut du courage pour affronter les choses qui me font peur").

Il peut également être particulièrement utile de noter vos pensées réalistes ou vos affirmations utiles pour faire face à la situation sur une fiche ou une feuille de papier. Gardez
 ensuite cette carte sur vous pour vous rappeler ces affirmations lorsque vous vous sentez trop bouleversé pour penser clairement.
Affronter ses peurs : Exposition

Il est normal de vouloir éviter les choses que vous craignez, car cela réduit votre anxiété à court terme. Par exemple, si vous avez peur des endroits petits et fermés comme les 
ascenseurs, vous serez moins anxieux si vous prenez les escaliers. Cependant, l'évitement vous empêche d'apprendre que les choses que vous craignez ne sont pas aussi dangereuses
 que vous le pensez. Ainsi, dans ce cas, prendre les escaliers vous empêche d'apprendre que rien de mal n'arrive lorsque vous prenez l'ascenseur.

Dans la TCC, le processus d'affrontement des peurs s'appelle l'exposition - et c'est l'étape la plus importante pour apprendre à gérer efficacement son anxiété. L'exposition 
consiste à entrer progressivement et de façon répétée dans des situations redoutées jusqu'à ce que vous vous sentiez moins anxieux. Vous commencez par des situations qui ne vous
 causent qu'un peu d'anxiété, puis vous passez progressivement à des situations qui vous causent beaucoup d'anxiété (voir Affronter ses peurs : exposition).

La première étape consiste à dresser une liste des situations, des lieux ou des objets qui vous font peur. Par exemple, si vous avez peur des araignées et que vous voulez surmonter
 cette peur pour pouvoir faire du camping avec des amis, la liste peut inclure : regarder des photos d'araignées, regarder des vidéos d'araignées, observer une araignée dans un
 aquarium et se tenir à l'autre bout de la pièce à côté d'une personne qui tient une araignée. Une fois la liste établie, classez-la de la moins effrayante à la plus effrayante.

En commençant par la situation qui vous cause le moins d'anxiété, pratiquez cette activité ou faites face à cette situation de façon répétée (par exemple, regarder des photos d'araignées) 
jusqu'à ce que vous commenciez à vous sentir moins anxieux. Lorsque vous pouvez faire face à cette situation spécifique plusieurs fois sans ressentir beaucoup d'anxiété, vous êtes 
prêt à passer à l'étape suivante de votre liste.

La TCC insiste sur l'importance de faire face à ses peurs de manière régulière. Plus vous vous entraînerez, plus vite vos peurs s'estomperont ! Le fait de connaître des succès 
et de se sentir bien dans sa peau est un puissant facteur de motivation pour continuer.
Comment prévenir une rechute

Gérer efficacement son problème, c'est un peu comme faire de l'exercice - il faut se "maintenir en forme" et faire de la pratique des compétences utiles une habitude quotidienne.
 Cependant, il arrive que les gens retombent dans leurs vieilles habitudes, perdent les améliorations qu'ils ont apportées et fassent une rechute. Une rechute est un retour complet
 à toutes vos anciennes façons de penser et de vous comporter avant d'avoir appris de nouvelles stratégies pour gérer votre problème. Bien qu'il soit normal que les gens 
fassent des écarts (un bref retour aux anciennes habitudes) en période de stress, de mauvaise humeur ou de fatigue, une rechute n'est certainement pas nécessaire. Voici quelques
 conseils sur la façon de prévenir les défaillances et les rechutes :

Continuez à mettre en pratique vos compétences en matière de TCC ! C'est le meilleur moyen d'éviter une rechute. Si vous vous exercez régulièrement, vous serez en mesure de faire
 face à toutes les situations auxquelles vous serez confronté.

Conseil : établissez un calendrier pour vous-même en indiquant les compétences que vous allez travailler chaque semaine.

Sachez à quel moment vous êtes plus susceptible de faire une rechute (p. ex. en période de stress ou de changement) et vous serez moins susceptible d'en faire une. Il est également
 utile de dresser une liste des signes avant-coureurs (p. ex., pensées plus anxieuses, disputes fréquentes avec des proches) qui vous indiquent que votre anxiété pourrait augmenter.
 Une fois que vous savez quels sont vos signes avant-coureurs ou vos " signaux d'alarme ", vous pouvez établir un plan d'action pour y faire face. Il peut s'agir, par exemple, 
de mettre en pratique certaines techniques de TCC, comme la respiration calme ou la remise en question de vos pensées négatives.

N'oubliez pas que, comme tout le monde sur terre, vous êtes un travail en cours ! Un bon moyen de prévenir les défaillances futures est de continuer à relever de nouveaux défis. 
Vous risquez moins de retomber dans vos vieilles habitudes si vous cherchez continuellement des moyens nouveaux et différents de surmonter votre anxiété.

Si vous avez eu une défaillance, essayez de comprendre quelle situation vous y a conduit. Cela peut vous aider à élaborer un plan pour faire face aux situations difficiles à l'avenir.
 Gardez à l'esprit qu'il est normal d'avoir des défaillances occasionnelles et que vous pouvez en tirer de nombreuses leçons.

La façon dont vous pensez à votre défaillance a un impact énorme sur votre comportement ultérieur. Si vous pensez que vous êtes un raté et que vous avez réduit à néant tous vos efforts,
 vous êtes plus susceptible d'arrêter d'essayer et de rechuter. Au contraire, il est important de garder à l'esprit qu'il est impossible de désapprendre toutes les compétences et 
de revenir à la case départ (c'est-à-dire avoir de l'anxiété et ne pas savoir comment la gérer), car vous savez comment gérer votre anxiété. Si vous avez une défaillance, vous pouvez
 vous remettre sur la bonne voie. C'est comme faire du vélo : une fois que vous savez en faire, vous ne l'oubliez pas ! Il se peut que vous soyez un peu rouillé, mais il ne faudra 
pas longtemps avant que vous soyez aussi bon qu'avant.

Rappelez-vous que les défaillances sont normales et peuvent être surmontées. Ne vous culpabilisez pas et ne vous traitez pas d'" idiot " ou de " perdant ", car cela n'aide pas. Soyez 
gentil avec vous-même, et réalisez que nous faisons tous des erreurs parfois !

Enfin, veillez à vous récompenser pour tout le travail que vous faites. Une récompense peut consister à sortir pour un bon repas ou à s'offrir une petite gâterie. La gestion de l'anxiété
 n'est pas toujours facile ou amusante, et vous méritez une récompense pour vos efforts !

